import numpy as np
import cv2 as cv
import rawpy
import imageio 

def ztifovani(fotka):
    priponanef='.NEF'
    priponatiff='.TIFF'
    path = fotka+priponanef
    raw = rawpy.imread(path)
    rgb = raw.postprocess()
    imageio.imsave(fotka+priponatiff, rgb)
    
def najdiSouradnice(fotka):
    priponajpg='.JPG'
    print(fotka+priponajpg)
    img_rgb = cv.imread(fotka+priponajpg)
    img_gray = cv.cvtColor(img_rgb, cv.COLOR_RGB2GRAY)
    template_lh = cv.imread('lh.jpg',0)
    template_ph = cv.imread('ph.jpg',0)
    template_ld = cv.imread('ld.jpg',0)
    template_pd = cv.imread('pd.jpg',0)
    # template_white = cv.imread('white.jpg',0)
    # template_black = cv.imread('black.jpg',0)
    w, h = template_lh.shape[::-1]
    # w1, h1 = template_white.shape[::-1]
    res_lh = cv.matchTemplate(img_gray,template_lh,cv.TM_CCOEFF_NORMED)
    res_ph = cv.matchTemplate(img_gray,template_ph,cv.TM_CCOEFF_NORMED)
    res_ld = cv.matchTemplate(img_gray,template_ld,cv.TM_CCOEFF_NORMED)
    res_pd = cv.matchTemplate(img_gray,template_pd,cv.TM_CCOEFF_NORMED)
    # res_white = cv.matchTemplate(img_gray,template_white,cv.TM_CCOEFF)
    # res_black = cv.matchTemplate(img_gray,template_black,cv.TM_CCOEFF)
    threshold = 0.65
    loc_lh = np.where( res_lh >= threshold)
    for pt in zip(*loc_lh[::-1]):
        cv.rectangle(img_rgb, pt, (pt[0] + w, pt[1] + h), (0,0,255), 5)
    loc_ph = np.where( res_ph >= threshold)
    for pt in zip(*loc_ph[::-1]):
        cv.rectangle(img_rgb, pt, (pt[0] + w, pt[1] + h), (0,0,255), 5)
    loc_ld = np.where( res_ld >= threshold)
    for pt in zip(*loc_ld[::-1]):
        cv.rectangle(img_rgb, pt, (pt[0] + w, pt[1] + h), (0,0,255), 5)
    loc_pd = np.where( res_pd >= threshold)
    for pt in zip(*loc_pd[::-1]):
        cv.rectangle(img_rgb, pt, (pt[0] + w, pt[1] + h), (0,0,255), 5)
    # loc_white = np.where( res_white >= threshold)
    # for pt in zip(*loc_ld[::-1]):
    #     cv.rectangle(img_rgb, pt, (pt[0] + w1, pt[1] + h1), (0,0,255), 5)
    # loc_black = np.where( res_black >= threshold)
    # for pt in zip(*loc_pd[::-1]):
    #     cv.rectangle(img_rgb, pt, (pt[0] + w1, pt[1] + h1), (0,0,255), 5)
    cv.imwrite('res.jpg',img_rgb)
    
    #cv.imshow(img_rgb)
    
    lh_y,lh_x = loc_lh
    ph_y,ph_x = loc_ph
    ld_y,ld_x = loc_ld
    pd_y,pd_x = loc_pd
    #Vnitřní souřadnice 
    lh_x=int(np.median(lh_x))
    lh_y=int(np.median(lh_y))
    ph_x=int(np.median(ph_x))
    ph_y=int(np.median(ph_y))
    ld_x=int(np.median(ld_x))
    ld_y=int(np.median(ld_y))
    pd_x=int(np.median(pd_x))
    pd_y=int(np.median(pd_y))
    
    # print(lh_x)
    # print(lh_y)
    # print(ph_x)
    # print(ph_y)
    # print(ld_x)
    # print(ld_y)
    # print(pd_x)
    # print(pd_y)
    
    return lh_x,lh_y,ph_x,ph_y,ld_x,ld_y,pd_x,pd_y

def ctverecky(fotka):
    priponajpg='.JPG'
    lh_x,lh_y,ph_x,ph_y,ld_x,ld_y,pd_x,pd_y = najdiSouradnice(fotka)
    delka=int(((ph_x-lh_x)+(pd_x-ld_x))/2)
    print(delka)
    vyska=int(((ld_y-lh_y)+(pd_y-ph_y))/2)
    print(vyska)
    startx = int(lh_x+(23/240)*delka)
    starty = int(lh_y+(23/157)*vyska)
    velikostctverecku = int((125/2405)*delka)
    mezera=int((154/2405)*delka)
    x = startx
    y = starty
    obr = cv.imread(fotka+priponajpg)
    pocatkyCtvercuX = np.zeros((40))
    pocatkyCtvercuY = np.zeros((40))
    for j in range(5):
        x = startx
        for i in range(8):
            pt1=(x,y)
            pt2=(x + velikostctverecku, y + velikostctverecku)
            cv.rectangle(obr, pt1, pt2, (0,0,255), 20)
            pocatkyCtvercuX[i+j*8]=x
            pocatkyCtvercuY[i+j*8]=y
            x = x + velikostctverecku + mezera
            print(pt1)
        y = y + velikostctverecku + mezera
    cv.imwrite('ctver.jpg',obr)
    # print(pocatkyCtvercuX)
    return startx,starty,velikostctverecku,mezera,pocatkyCtvercuX,pocatkyCtvercuY

# def zapisdada(fotka):
    priponanef='.NEF'
    startx,starty,velikostctverecku,mezera,pocatkyCtvercuX,pocatkyCtvercuY=ctverecky(fotka)

def countyZCtverecku(fotka):
    priponatiff='.TIFF'
    soubor=fotka+priponatiff
    startx,starty,velikostctverecku,mezera,pocatkyCtvercuX,pocatkyCtvercuY=ctverecky(fotka)
    tif = imageio.imread(soubor)
    cervena=np.zeros(40)
    zelena=np.zeros(40)
    modra=np.zeros(40)
    for i in range(40):
        x=int(pocatkyCtvercuX[i]+8)
        y=int(pocatkyCtvercuY[i]+8)
        cer=np.zeros(int(velikostctverecku*velikostctverecku))
        zel=np.zeros(int(velikostctverecku*velikostctverecku))
        mod=np.zeros(int(velikostctverecku*velikostctverecku))
        for j in range(int(velikostctverecku)):
            for k in range(int(velikostctverecku)):
                cer[int(velikostctverecku*j+k)]=format(tif[y+k,x+j,0])
                zel[int(velikostctverecku*j+k)]=format(tif[y+k,x+j,1])
                mod[int(velikostctverecku*j+k)]=format(tif[y+k,x+j,2])
        cervena[i]=np.median(cer)
        zelena[i]=np.median(zel)
        modra[i]=np.median(mod)
    print('Červená')
    print(cervena)
    print('Zelená')
    print(zelena)
    print('Modrá')
    print(modra)
    return cervena,zelena, modra

def standardy(fotka,swx,swy,sbx,sby):
    priponatiff='.TIFF'
    soubor=fotka+priponatiff
    tif = imageio.imread(soubor)
    wr=format(tif[swy,swx,0])
    wg=format(tif[swy,swx,1])
    wb=format(tif[swy,swx,2])
    br=format(tif[sby,sbx,0])
    bg=format(tif[sby,sbx,1])
    bb=format(tif[sby,sbx,2])
    return wr,wg,wb,br,bg,bb

yon='a'
ii=0
while yon=='a':    
    filename1=str(input('Zapiš název snímku s filtrem PFCL-A (bez přípony): '))
    filename2=str(input('Zapiš název snímku s filtrem PFCL-B (bez přípony): '))
    boolbarvy=int(ii)
    # souřadnice standardů
    swx=1330
    swy=3560
    aorn=str(input('Odpovídají souřadnice bílého standardu '+str(swx)+':'+str(swy)+'? (a/n): '))
    if aorn == 'n':
        swx=int(input('Zadej x-ovou souřadnici bíleho standardu: '))
        swy=int(input('Zadej x-ovou souřadnici bíleho standardu: '))
    else:
        pass
    sbx=7520
    sby=3960
    aorn=str(input('Odpovídají souřadnice černého standardu '+str(sbx)+':'+str(sby)+'? (a/n): '))
    if aorn == 'n':
        swx=int(input('Zadej x-ovou souřadnici černého standardu: '))
        swy=int(input('Zadej x-ovou souřadnici černého standardu: '))
    else:
        pass
    
    
    ztifovani(filename1)
    ztifovani(filename2)
    # ctverecky(filename1)
    # ctverecky(filename2)
    cervena1, zelena1, modra1 = countyZCtverecku(filename1)
    cervena2, zelena2, modra2 = countyZCtverecku(filename2)
    # normalizace
    wr1,wg1,wb1,br1,bg1,bb1 = standardy(filename1,swx,swy,sbx,sby)
    wr2,wg2,wb2,br2,bg2,bb2 = standardy(filename2,swx,swy,sbx,sby)
    cervena1=cervena1-np.ones(40)*float(br1)
    zelena1=zelena1-np.ones(40)*float(bg1)
    modra1=modra1-np.ones(40)*float(bb1)
    cervena2=cervena2-np.ones(40)*float(br2)
    zelena2=zelena2-np.ones(40)*float(bg2)
    modra2=modra2-np.ones(40)*float(bb2)
    cervena1=cervena1/float(wr1)
    zelena1=zelena1/float(wg1)
    modra1=modra1/float(wb1)
    cervena2=cervena2/float(wr2)
    zelena2=zelena2/float(wg2)
    modra2=modra2/float(wb2)
    
    for i in range(40):
        data = open('data.csv','a')
        c1=cervena1[i]
        z1=zelena1[i]
        m1=modra1[i]
        c2=cervena2[i]
        z2=zelena2[i]
        m2=modra2[i]
        data.write(str(boolbarvy) +','+ str(c1) +','+ str(z1) +','+ str(m1) +','+ str(c2) +','+ str(z2) +','+ str(m2)+'\n')
        data.close()
    yon=str(input('Chcete přdat další barvu? (a/n): '))
    ii=ii+1
    